diff -uNrd ircd-hybrid-6.0/src/m_away.c ircd-pi1.0a/src/m_away.c
--- ircd-hybrid-6.0/src/m_away.c	Fri Jul 30 02:40:13 1999
+++ ircd-pi1.0a/src/m_away.c	Fri May 10 23:49:04 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_away.c,v 1.2 1999/07/30 06:40:13 tomh Exp $
+ *   $Id: m_away.c,v 1.5 2002/05/11 03:49:04 smoli Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -30,6 +30,7 @@
 #include "send.h"
 
 #include <stdlib.h>
+#include <string.h>
 
 /*
  * m_functions execute protocol messages on this server:
@@ -143,7 +144,7 @@
 
   /* Marking as away */
   
-  if (strlen(awy2) > (size_t) TOPICLEN)
+  if (irclen(awy2) > (size_t) TOPICLEN)
     awy2[TOPICLEN] = '\0';
 /* some lamers scripts continually do a /away, hence making a lot of
    unnecessary traffic. *sigh* so... as comstud has done, I've
@@ -155,7 +156,7 @@
   if (away)
     MyFree(away);
 
-  away = (char *)MyMalloc(strlen(awy2)+1);
+  away = (char *)MyMalloc(irclen(awy2)+1);
   strcpy(away,awy2);
 
   sptr->user->away = away;
diff -uNrd ircd-hybrid-6.0/src/m_broadcast.c ircd-pi1.0a/src/m_broadcast.c
--- ircd-hybrid-6.0/src/m_broadcast.c	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/src/m_broadcast.c	Wed May 22 07:07:10 2002
@@ -0,0 +1,66 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, src/m_broadcast.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  $Id: m_broadcast.c,v 1.1 2002/05/22 11:07:10 smoli Exp $
+ */
+
+#include "client.h"
+#include "numeric.h"
+#include "ircd.h"
+#include "s_user.h"
+#include "send.h"
+
+#include <string.h>
+
+/*
+ * m_broadcast()
+ *
+ * parv[0] = sender prefix
+ * parv[1] = new hostname
+ *
+ */
+int m_broadcast(struct Client *cptr,
+                struct Client *sptr,
+                int parc,
+                char *parv[])
+{
+  if(MyConnect(sptr))
+    { 
+      if(!IsOper(sptr) && !IsServer(cptr))
+        {
+          sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+          return 0;
+        }
+  
+      if(parc < 2)
+        {
+          sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+                     me.name, parv[0], "BROADCAST");
+          return 0;
+        }
+    }
+  
+  sendto_serv_butone(cptr, ":%s BROADCAST :%s", parv[0], parv[1]);
+  sendto_myclients(sptr, parv[1]);
+  
+  return 1;
+}
diff -uNrd ircd-hybrid-6.0/src/m_capab.c ircd-pi1.0a/src/m_capab.c
--- ircd-hybrid-6.0/src/m_capab.c	Wed Jul 28 02:57:56 1999
+++ ircd-pi1.0a/src/m_capab.c	Fri May 10 23:49:04 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_capab.c,v 1.1 1999/07/28 06:57:56 tomh Exp $
+ *   $Id: m_capab.c,v 1.5 2002/05/11 03:49:04 smoli Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -28,6 +28,7 @@
 #include "s_serv.h"
 
 #include <assert.h>
+#include <string.h>
 
 /*
  * m_functions execute protocol messages on this server:
@@ -97,19 +98,19 @@
   char* p;
   char* s;
 
-  if ((!IsUnknown(cptr) && !IsHandshake(cptr)) || parc < 2)
+  if((!IsUnknown(cptr) && !IsHandshake(cptr)) || parc < 2)
     return 0;
 
-  if (cptr->caps)
+  if(cptr->caps)
     return exit_client(cptr, cptr, cptr, "CAPAB received twice");
   else
     cptr->caps |= CAP_CAP;
 
-  for (s = strtoken(&p, parv[1], " "); s; s = strtoken(&p, NULL, " "))
+  for(s = strtoken(&p, parv[1], " "); s; s = strtoken(&p, NULL, " "))
     {
-      for (cap = captab; cap->name; cap++)
+      for(cap = captab; cap->name; cap++)
         {
-          if (0 == strcmp(cap->name, s))
+          if(!irccmp(cap->name, s))
             {
               cptr->caps |= cap->cap;
               break;
diff -uNrd ircd-hybrid-6.0/src/m_close.c ircd-pi1.0a/src/m_close.c
--- ircd-hybrid-6.0/src/m_close.c	Fri Jul 30 00:01:32 1999
+++ ircd-pi1.0a/src/m_close.c	Fri Nov  2 19:23:30 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_close.c,v 1.1 1999/07/30 04:01:32 tomh Exp $
+ *   $Id: m_close.c,v 1.1.1.1 2001/11/03 00:23:30 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_connect.c ircd-pi1.0a/src/m_connect.c
--- ircd-hybrid-6.0/src/m_connect.c	Tue Nov 21 01:49:29 2000
+++ ircd-pi1.0a/src/m_connect.c	Fri Nov  2 19:23:30 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_connect.c,v 1.5 2000/11/21 06:49:29 lusky Exp $
+ *   $Id: m_connect.c,v 1.1.1.1 2001/11/03 00:23:30 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_die.c ircd-pi1.0a/src/m_die.c
--- ircd-hybrid-6.0/src/m_die.c	Thu Jun  8 21:59:07 2000
+++ ircd-pi1.0a/src/m_die.c	Sun May  5 00:42:24 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_die.c,v 1.3 2000/06/09 01:59:07 lusky Exp $
+ *   $Id: m_die.c,v 1.4 2002/05/05 04:42:24 smoli Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -30,6 +30,8 @@
 #include "s_bsd.h"
 #include "s_log.h"
 #include "send.h"
+
+#include <stdlib.h>
 
 /*
  * m_functions execute protocol messages on this server:
diff -uNrd ircd-hybrid-6.0/src/m_error.c ircd-pi1.0a/src/m_error.c
--- ircd-hybrid-6.0/src/m_error.c	Sat Nov 18 14:11:12 2000
+++ ircd-pi1.0a/src/m_error.c	Fri Nov  2 19:23:30 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_error.c,v 1.3 2000/11/18 19:11:12 lusky Exp $
+ *   $Id: m_error.c,v 1.1.1.1 2001/11/03 00:23:30 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_gline.c ircd-pi1.0a/src/m_gline.c
--- ircd-hybrid-6.0/src/m_gline.c	Fri Dec  1 01:28:48 2000
+++ ircd-pi1.0a/src/m_gline.c	Tue May 14 00:03:35 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: m_gline.c,v 1.41 2000/12/01 06:28:48 lusky Exp $
+ *  $Id: m_gline.c,v 1.4 2002/05/14 04:03:35 smoli Exp $
  */
 #include "m_gline.h"
 #include "channel.h"
@@ -287,16 +287,7 @@
    log_gline_request(oper_name,oper_username,oper_host,oper_server,
                      user,host,reason);
 
-   sendto_realops("%s!%s@%s on %s is requesting gline for [%s@%s] [%s]",
-                  oper_name,
-                  oper_username,
-                  oper_host,
-                  oper_server,
-                  user,
-                  host,
-                  reason);
-
-  /* If at least 3 opers agree this user should be G lined then do it */
+  /* If at least 2 opers agree this user should be G lined then do it */
   if(majority_gline(sptr,
                     oper_name,
                     oper_username,
@@ -334,6 +325,16 @@
 
       return 0;
     }
+  else
+    sendto_realops("%s!%s@%s on %s is requesting gline for [%s@%s] [%s]",
+                   oper_name,
+                   oper_username,
+                   oper_host,
+                   oper_server,
+                   user,
+                   host,
+                   reason);
+
 #endif  
   return 0;
 }
@@ -376,7 +377,7 @@
            oper_nick,oper_user,oper_host,oper_server,
            timebuffer);
 
-  if (write(out, buffer, strlen(buffer)) <= 0)
+  if (write(out, buffer, irclen(buffer)) <= 0)
     {
       sendto_realops("*** Problem writing to %s",filenamebuf);
     }
@@ -434,7 +435,7 @@
   if (safe_write(sptr,filenamebuf,out,buffer))
     return;
 
-  ircsprintf(buffer, "#%s!%s@%s on %s [%s]\n",
+/*  ircsprintf(buffer, "#%s!%s@%s on %s [%s]\n",
                    gline_pending_ptr->oper_nick2,
                    gline_pending_ptr->oper_user2,
                    gline_pending_ptr->oper_host2,
@@ -443,7 +444,7 @@
                    (gline_pending_ptr->reason2):"No reason");
 
   if (safe_write(sptr, filenamebuf, out, buffer))
-    return;
+    return;*/
 
   ircsprintf(buffer, "#%s!%s@%s on %s [%s]\n",
                    oper_nick,
@@ -613,7 +614,7 @@
                      gline_pending_ptr->host,
                      gline_pending_ptr->reason1);
 
-          if(gline_pending_ptr->oper_nick2[0])
+/*          if(gline_pending_ptr->oper_nick2[0])
             {
               tmptr = localtime(&gline_pending_ptr->time_request2);
               strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
@@ -628,7 +629,7 @@
                          gline_pending_ptr->user,
                          gline_pending_ptr->host,
                          gline_pending_ptr->reason2);
-            }
+            }*/
           gline_pending_ptr = gline_pending_ptr->next;
         }
       sendto_one(sptr,":%s NOTICE %s :End of Pending G-lines", me.name,
@@ -719,7 +720,7 @@
           tmp_pending_ptr = gline_pending_ptr;
           gline_pending_ptr = gline_pending_ptr->next;
           MyFree(tmp_pending_ptr->reason1);
-          MyFree(tmp_pending_ptr->reason2);
+//          MyFree(tmp_pending_ptr->reason2);
           MyFree(tmp_pending_ptr);
         }
       else
@@ -757,7 +758,7 @@
   strncpy_irc(pending->user, user, USERLEN);
   strncpy_irc(pending->host, host, HOSTLEN);
   DupString(pending->reason1, reason);
-  pending->reason2 = NULL;
+//  pending->reason2 = NULL;
 
   pending->last_gline_time = CurrentTime;
   pending->time_request1 = CurrentTime;
@@ -772,11 +773,11 @@
  * inputs       - oper_nick, oper_user, oper_host, oper_server
  *                user,host reason
  *
- * output       - YES if there are 3 different opers on 3 different servers
+ * output       - YES if there are 2 different opers on 2 different servers
  *                agreeing to this gline, NO if there are not.
  * Side effects -
  *      See if there is a majority agreement on a GLINE on the given user
- *      There must be at least 3 different opers agreeing on this GLINE
+ *      There must be at least 2 different opers agreeing on this GLINE
  *
  *      Expire old entries.
  */
@@ -816,20 +817,20 @@
               /* This oper or server has already "voted" */
               sendto_realops("oper or server has already voted");
               return NO;
-            }
+/*            }
 
           if(gline_pending_ptr->oper_user2[0] != '\0')
             {
-              /* if two other opers on two different servers have voted yes */
+              // if two other opers on two different servers have voted yes 
 
               if(((irccmp(gline_pending_ptr->oper_user2,oper_user)==0) &&
                   (irccmp(gline_pending_ptr->oper_host2,oper_host)==0)) ||
                   (irccmp(gline_pending_ptr->oper_server2,oper_server)==0))
                 {
-                  /* This oper or server has already "voted" */
+                  // This oper or server has already "voted" 
                   sendto_realops("oper or server has already voted");
                   return NO;
-                }
+*/                }
 
               if(find_is_glined(host, user))
                 return NO;
@@ -844,16 +845,16 @@
             }
           else
             {
-              strncpy_irc(gline_pending_ptr->oper_nick2, oper_nick, NICKLEN);
+/*              strncpy_irc(gline_pending_ptr->oper_nick2, oper_nick, NICKLEN);
               strncpy_irc(gline_pending_ptr->oper_user2, oper_user, USERLEN);
               strncpy_irc(gline_pending_ptr->oper_host2, oper_host, HOSTLEN);
               DupString(gline_pending_ptr->reason2, reason);
-              gline_pending_ptr->oper_server2 = find_or_add(oper_server);
+              gline_pending_ptr->oper_server2 = find_or_add(oper_server); */
               gline_pending_ptr->last_gline_time = CurrentTime;
               gline_pending_ptr->time_request1 = CurrentTime;
               return NO;
             }
-        }
+//        }
     }
   /* Didn't find this user@host gline in pending gline list
    * so add it.
@@ -878,6 +879,64 @@
 {
   aconf->next = glines;
   glines = aconf;
+}
+
+/* remove_gline
+ *
+ * inputs       - user, host
+ * output       - YES if gline has been found and removed, else - NO
+ *
+ * Remove gline for given host and user from glines list.
+ *
+ * -decho
+ */
+
+int remove_gline_match(char *host, char *user)
+{
+
+  aConfItem *kill_list_ptr;
+  aConfItem *last_list_ptr;
+  aConfItem *tmp_list_ptr;
+  int iFound;
+
+  iFound = 0;
+
+  if(glines)
+    {
+      kill_list_ptr = last_list_ptr = glines;
+
+      while(kill_list_ptr)
+        {
+
+           if(
+               (strcasecmp(kill_list_ptr->host,host)==0) && (strcasecmp(kill_list_ptr->name,user )==0)
+             ) // match
+            {
+              if(glines == kill_list_ptr)
+                {
+                  glines = last_list_ptr = tmp_list_ptr =
+                    kill_list_ptr->next;
+                }
+              else
+                {
+                  /* its in the middle of the list, so link around it */
+                  tmp_list_ptr = last_list_ptr->next = kill_list_ptr->next;
+                }
+              free_conf(kill_list_ptr);
+              kill_list_ptr = tmp_list_ptr;
+              iFound = 1;
+            }
+           else {
+             last_list_ptr = kill_list_ptr;
+             kill_list_ptr = kill_list_ptr->next;
+           }
+        }
+    }
+
+  if( iFound )
+    return YES;
+  else
+    return NO;
 }
 
 #endif /* GLINES */
diff -uNrd ircd-hybrid-6.0/src/m_help.c ircd-pi1.0a/src/m_help.c
--- ircd-hybrid-6.0/src/m_help.c	Thu Jul 29 03:11:48 1999
+++ ircd-pi1.0a/src/m_help.c	Fri Nov  2 19:23:31 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_help.c,v 1.1 1999/07/29 07:11:48 tomh Exp $
+ *   $Id: m_help.c,v 1.1.1.1 2001/11/03 00:23:31 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_htm.c ircd-pi1.0a/src/m_htm.c
--- ircd-hybrid-6.0/src/m_htm.c	Fri Jul 30 02:40:14 1999
+++ ircd-pi1.0a/src/m_htm.c	Fri Nov  2 19:23:31 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_htm.c,v 1.1 1999/07/30 06:40:14 tomh Exp $
+ *   $Id: m_htm.c,v 1.1.1.1 2001/11/03 00:23:31 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_info.c ircd-pi1.0a/src/m_info.c
--- ircd-hybrid-6.0/src/m_info.c	Tue Nov 21 01:49:29 2000
+++ ircd-pi1.0a/src/m_info.c	Fri Nov  2 19:23:31 2001
@@ -1,7 +1,7 @@
 /*
  * m_info.c 
  *
- * $Id: m_info.c,v 1.38 2000/11/21 06:49:29 lusky Exp $
+ * $Id: m_info.c,v 1.1.1.1 2001/11/03 00:23:31 shifty Exp $
  */
 #define DEFINE_M_INFO_DATA
 #include "m_info.h"
@@ -15,6 +15,7 @@
 #include "s_user.h"
 #include "send.h"
 #include "struct.h"
+#include "s_conf.h"
 
 #include <time.h>
 #include <string.h>
@@ -100,7 +101,7 @@
     sendto_one(sptr, form_str(RPL_INFO), me.name, parv[0], "");
 
     sendto_one(sptr,
-      ":%s %d %s :Birth Date: %s, compile # %s",
+      ":%s %d %s :Birth Date: %s, compile #%s",
       me.name,
       RPL_INFO,
       parv[0],
@@ -114,7 +115,7 @@
       parv[0],
       myctime(me.firsttime));
 
-    sendto_one(sptr, form_str(RPL_ENDOFINFO), me.name, parv[0]);
+  sendto_one(sptr, form_str(RPL_ENDOFINFO), me.name, parv[0]);
   } /* if (hunt_server(cptr,sptr,":%s INFO :%s",1,parc,parv) == HUNTED_ISME) */
 
   return 0;
diff -uNrd ircd-hybrid-6.0/src/m_ison.c ircd-pi1.0a/src/m_ison.c
--- ircd-hybrid-6.0/src/m_ison.c	Thu Oct 14 02:14:43 1999
+++ ircd-pi1.0a/src/m_ison.c	Fri May 10 23:49:04 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_ison.c,v 1.4 1999/10/14 06:14:43 lusky Exp $
+ *   $Id: m_ison.c,v 1.2 2002/05/11 03:49:04 smoli Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -122,7 +122,7 @@
     }
 
   ircsprintf(buf, form_str(RPL_ISON), me.name, parv[0]);
-  len = strlen(buf);
+  len = irclen(buf);
   current_insert_point = buf + len;
 
   if (!IsOper(cptr))
@@ -138,7 +138,7 @@
         *end_of_current_nick = '\0';
       if ((acptr = find_person(current_nick, NULL)))
 	{
-	  len = strlen(acptr->name);
+	  len = irclen(acptr->name);
 	  if( (current_insert_point + (len + 5)) < (buf + sizeof(buf)) )
 	    {
 	      memcpy((void *)current_insert_point,
diff -uNrd ircd-hybrid-6.0/src/m_kill.c ircd-pi1.0a/src/m_kill.c
--- ircd-hybrid-6.0/src/m_kill.c	Tue Nov 21 01:49:29 2000
+++ ircd-pi1.0a/src/m_kill.c	Fri May 10 23:49:05 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_kill.c,v 1.7 2000/11/21 06:49:29 lusky Exp $
+ *   $Id: m_kill.c,v 1.2 2002/05/11 03:49:05 smoli Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -134,7 +134,7 @@
   if (IsAnOper(cptr))
     {
       if (!BadPtr(path))
-        if (strlen(path) > (size_t) KILLLEN)
+        if (irclen(path) > (size_t) KILLLEN)
           path[KILLLEN] = '\0';
     }
 
diff -uNrd ircd-hybrid-6.0/src/m_kline.c ircd-pi1.0a/src/m_kline.c
--- ircd-hybrid-6.0/src/m_kline.c	Tue Aug 22 01:03:59 2000
+++ ircd-pi1.0a/src/m_kline.c	Fri Nov  2 19:23:32 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_kline.c,v 1.55 2000/08/22 05:03:59 lusky Exp $
+ *   $Id: m_kline.c,v 1.1.1.1 2001/11/03 00:23:32 shifty Exp $
  */
 #include "m_kline.h"
 #include "channel.h"
diff -uNrd ircd-hybrid-6.0/src/m_links.c ircd-pi1.0a/src/m_links.c
--- ircd-hybrid-6.0/src/m_links.c	Sat Nov 25 01:01:01 2000
+++ ircd-pi1.0a/src/m_links.c	Tue May 14 00:03:35 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_links.c,v 1.6 2000/11/25 06:01:01 lusky Exp $
+ *   $Id: m_links.c,v 1.3 2002/05/14 04:03:35 smoli Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -29,6 +29,7 @@
 #include "numeric.h"
 #include "s_serv.h"
 #include "send.h"
+#include "config.h"
 
 #include <assert.h>
 #include <string.h>
@@ -182,8 +183,11 @@
         continue;
       if(IsAnOper(sptr))
          sendto_one(sptr, form_str(RPL_LINKS),
-                    me.name, parv[0], acptr->name, acptr->serv->up,
-                    acptr->hopcount, (acptr->info[0] ? acptr->info :
+                    me.name, parv[0], acptr->name, acptr->serv->up, acptr->hopcount,
+#ifdef HAVE_SSL
+                    (IsSSLServ(acptr) ? "S" : ""),
+#endif                   
+                    (acptr->info[0] ? acptr->info :
                                       "(Unknown Location)"));
       else
         {
@@ -201,6 +205,17 @@
           else
             p = "(Unknown Location)";
 
+#ifdef HAVE_SSL
+#ifdef SERVERHIDE
+          sendto_one(sptr, form_str(RPL_LINKS),
+                    me.name, parv[0], acptr->name, NETWORK_DESC,
+                     0, ((IsSSLUmode(sptr) || IsAnOper(sptr)) && IsSSLServ(acptr)) ? "S" : "", p);
+#else
+          sendto_one(sptr, form_str(RPL_LINKS),
+                    me.name, parv[0], acptr->name, acptr->serv->up,
+                     acptr->hopcount, ((IsSSLUmode(sptr) || IsAnOper(sptr)) && IsSSLServ(acptr)) ? "S" : "", p);
+#endif
+#else
 #ifdef SERVERHIDE
           sendto_one(sptr, form_str(RPL_LINKS),
                     me.name, parv[0], acptr->name, NETWORK_DESC,
@@ -209,6 +224,7 @@
           sendto_one(sptr, form_str(RPL_LINKS),
                     me.name, parv[0], acptr->name, acptr->serv->up,
                     acptr->hopcount, p);
+#endif
 #endif
         }
 
diff -uNrd ircd-hybrid-6.0/src/m_list.c ircd-pi1.0a/src/m_list.c
--- ircd-hybrid-6.0/src/m_list.c	Tue Nov 21 01:49:30 2000
+++ ircd-pi1.0a/src/m_list.c	Fri Nov  2 19:23:32 2001
@@ -3,7 +3,7 @@
  *   Copyright (C) 1990 Jarkko Oikarinen and
  *                      University of Oulu, Co Center
  *
- * $Id: m_list.c,v 1.3 2000/11/21 06:49:30 lusky Exp $ 
+ * $Id: m_list.c,v 1.1.1.1 2001/11/03 00:23:32 shifty Exp $ 
  *
  *   This program is free software; you can redistribute it and/or modify
  *   it under the terms of the GNU General Public License as published by
diff -uNrd ircd-hybrid-6.0/src/m_locops.c ircd-pi1.0a/src/m_locops.c
--- ircd-hybrid-6.0/src/m_locops.c	Mon Aug  9 22:46:24 1999
+++ ircd-pi1.0a/src/m_locops.c	Fri Nov  2 19:23:32 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_locops.c,v 1.2 1999/08/10 02:46:24 lusky Exp $
+ *   $Id: m_locops.c,v 1.1.1.1 2001/11/03 00:23:32 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_ltrace.c ircd-pi1.0a/src/m_ltrace.c
--- ircd-hybrid-6.0/src/m_ltrace.c	Fri Nov 24 13:51:17 2000
+++ ircd-pi1.0a/src/m_ltrace.c	Fri Nov  2 19:23:33 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_ltrace.c,v 1.5 2000/11/24 18:51:17 lusky Exp $
+ *   $Id: m_ltrace.c,v 1.1.1.1 2001/11/03 00:23:33 shifty Exp $
  */
 #include "m_commands.h"
 #include "class.h"
diff -uNrd ircd-hybrid-6.0/src/m_lusers.c ircd-pi1.0a/src/m_lusers.c
--- ircd-hybrid-6.0/src/m_lusers.c	Thu Jul 29 03:11:48 1999
+++ ircd-pi1.0a/src/m_lusers.c	Fri Nov  2 19:23:33 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_lusers.c,v 1.1 1999/07/29 07:11:48 tomh Exp $
+ *   $Id: m_lusers.c,v 1.1.1.1 2001/11/03 00:23:33 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_message.c ircd-pi1.0a/src/m_message.c
--- ircd-hybrid-6.0/src/m_message.c	Sun Sep 10 04:42:49 2000
+++ ircd-pi1.0a/src/m_message.c	Fri Nov  2 19:23:33 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_message.c,v 1.11 2000/09/10 08:42:49 lusky Exp $
+ *   $Id: m_message.c,v 1.1.1.1 2001/11/03 00:23:33 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_mode.c ircd-pi1.0a/src/m_mode.c
--- ircd-hybrid-6.0/src/m_mode.c	Fri Jul 30 22:42:56 1999
+++ ircd-pi1.0a/src/m_mode.c	Fri Nov  2 19:23:33 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_mode.c,v 1.1 1999/07/31 02:42:56 tomh Exp $
+ *   $Id: m_mode.c,v 1.1.1.1 2001/11/03 00:23:33 shifty Exp $
  */
 #include "m_commands.h"
 #include "channel.h"
diff -uNrd ircd-hybrid-6.0/src/m_oper.c ircd-pi1.0a/src/m_oper.c
--- ircd-hybrid-6.0/src/m_oper.c	Fri Dec  1 01:28:49 2000
+++ ircd-pi1.0a/src/m_oper.c	Tue May 21 22:14:29 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_oper.c,v 1.8 2000/12/01 06:28:49 lusky Exp $
+ *   $Id: m_oper.c,v 1.7 2002/05/22 02:14:29 smoli Exp $
  */
 
 #include "m_commands.h"
@@ -37,7 +37,7 @@
 
 #include <fcntl.h>
 #include <unistd.h>
-
+#include <string.h>
 
 /*
  * m_functions execute protocol messages on this server:
@@ -174,7 +174,7 @@
 #endif  /* CRYPT_OPER_PASSWORD */
 
   if ((aconf->status & CONF_OPS) &&
-      0 == strcmp(encr, aconf->passwd) && !attach_conf(sptr, aconf))
+      !strcmp(encr, aconf->passwd) && !attach_conf(sptr, aconf))
     {
       int old = (sptr->umodes & ALL_UMODES);
       
@@ -200,7 +200,9 @@
               sptr->umodes |= ((int)aconf->hold & ALL_UMODES); 
               if( !IsSetOperN(sptr) )
                 sptr->umodes &= ~FLAGS_NCHANGE;
-              
+#ifdef ENFORCE
+              sptr->umodes &= ~FLAGS_ENFORCE;
+#endif /* ENFORCE */
               sendto_one(sptr, ":%s NOTICE %s :*** Oper flags set from conf",
                          me.name,parv[0]);
             }
@@ -261,14 +263,15 @@
            */
 
           if (IsPerson(sptr) &&
-              (logfile = open(FNAME_OPERLOG, O_WRONLY|O_APPEND)) != -1)
+              ((logfile = open(FNAME_OPERLOG, O_WRONLY|O_APPEND)) != -1 ||
+               (logfile = open(FNAME_OPERLOG, O_WRONLY|O_CREAT)) != -1))
             {
               /* (void)alarm(0); */
               ircsprintf(buf, "%s OPER (%s) by (%s!%s@%s)\n",
                                myctime(CurrentTime), name, 
                                parv[0], sptr->username,
                                sptr->host);
-              write(logfile, buf, strlen(buf));
+              write(logfile, buf, irclen(buf));
               close(logfile);
             }
         }
diff -uNrd ircd-hybrid-6.0/src/m_operwall.c ircd-pi1.0a/src/m_operwall.c
--- ircd-hybrid-6.0/src/m_operwall.c	Mon Aug  9 22:46:24 1999
+++ ircd-pi1.0a/src/m_operwall.c	Fri Nov  2 19:23:33 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_operwall.c,v 1.2 1999/08/10 02:46:24 lusky Exp $
+ *   $Id: m_operwall.c,v 1.1.1.1 2001/11/03 00:23:33 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_pass.c ircd-pi1.0a/src/m_pass.c
--- ircd-hybrid-6.0/src/m_pass.c	Wed Jul 28 03:49:36 1999
+++ ircd-pi1.0a/src/m_pass.c	Fri Nov  2 19:23:33 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: m_pass.c,v 1.2 1999/07/28 07:49:36 tomh Exp $
+ *  $Id: m_pass.c,v 1.1.1.1 2001/11/03 00:23:33 shifty Exp $
  */
 #include "m_commands.h"  /* m_pass prototype */
 #include "client.h"      /* client struct */
diff -uNrd ircd-hybrid-6.0/src/m_ping.c ircd-pi1.0a/src/m_ping.c
--- ircd-hybrid-6.0/src/m_ping.c	Thu Jul 29 23:25:51 1999
+++ ircd-pi1.0a/src/m_ping.c	Fri Nov  2 19:23:33 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_ping.c,v 1.1 1999/07/30 03:25:51 db Exp $
+ *   $Id: m_ping.c,v 1.1.1.1 2001/11/03 00:23:33 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_pong.c ircd-pi1.0a/src/m_pong.c
--- ircd-hybrid-6.0/src/m_pong.c	Fri Jun  9 22:45:36 2000
+++ ircd-pi1.0a/src/m_pong.c	Fri Nov  2 19:23:33 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_pong.c,v 1.2 2000/06/10 02:45:36 lusky Exp $
+ *   $Id: m_pong.c,v 1.1.1.1 2001/11/03 00:23:33 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_quit.c ircd-pi1.0a/src/m_quit.c
--- ircd-hybrid-6.0/src/m_quit.c	Fri Jul 30 20:23:46 1999
+++ ircd-pi1.0a/src/m_quit.c	Fri May 10 23:49:05 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_quit.c,v 1.1 1999/07/31 00:23:46 db Exp $
+ *   $Id: m_quit.c,v 1.5 2002/05/11 03:49:05 smoli Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -28,6 +28,9 @@
 #include "numeric.h"
 #include "s_serv.h"
 #include "send.h"
+#include "irc_string.h"
+
+#include <string.h>
 
 /*
  * m_functions execute protocol messages on this server:
@@ -99,7 +102,7 @@
   char *comment = (parc > 1 && parv[1]) ? parv[1] : cptr->name;
 
   sptr->flags |= FLAGS_NORMALEX;
-  if (strlen(comment) > (size_t) TOPICLEN)
+  if (irclen(comment) > (size_t) TOPICLEN)
     comment[TOPICLEN] = '\0';
 
 #ifdef ANTI_SPAM_EXIT_MESSAGE
diff -uNrd ircd-hybrid-6.0/src/m_rehash.c ircd-pi1.0a/src/m_rehash.c
--- ircd-hybrid-6.0/src/m_rehash.c	Thu Dec 21 21:28:11 2000
+++ ircd-pi1.0a/src/m_rehash.c	Fri Nov  2 19:23:33 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_rehash.c,v 1.7 2000/12/22 02:28:11 lusky Exp $
+ *   $Id: m_rehash.c,v 1.1.1.1 2001/11/03 00:23:33 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/m_restart.c ircd-pi1.0a/src/m_restart.c
--- ircd-hybrid-6.0/src/m_restart.c	Thu Jun  8 21:59:07 2000
+++ ircd-pi1.0a/src/m_restart.c	Fri Nov  2 19:23:33 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_restart.c,v 1.3 2000/06/09 01:59:07 lusky Exp $
+ *   $Id: m_restart.c,v 1.1.1.1 2001/11/03 00:23:33 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
